#include<iostream>
using namespace std;

int main()
{
    int n,i,j;
    cin>>n;
    int a[n][4];
    for(i=0;i<n;i++)
        for(j=0;j<4;j++)
            a[i][j]=0;
    int zaliha[4],kolicina[n];
    for(i=0;i<4;i++)
        cin>>zaliha[i];
    char *krv;
    for(i=0;i<n;i++)
    {
        cin>>krv>>kolicina[i];
        if(krv[0]=='O')
            a[i][0]=kolicina[i];
        else if(krv[1]=='B')
            a[i][3]=kolicina[i];
        else if(krv[0]=='B')
            a[i][2]=kolicina[i];
        else
            a[i][1]=kolicina[i];

    }
    int k=0,zam;
    for(int i=0;i<n;i++)
    {
        if(k>3)
        {
            cout<<"nemoguce";
            return 0;
        }
        while(a[i][3]==0)
            i++;
        if(zaliha[3-k]>a[i][3])
            zaliha[3-k]-=a[i][3];
        else if(zaliha[3-k]==0)
        {
            k++;
            i--;
        }
        else
        {
            zam=a[i][3]-zaliha[3-k];
            a[i][3]=zaliha[3-k];
            zaliha[3-k]=0;
            for(j=0;zam!=0&&j<=3;j++)
            {
                if(zaliha[3-k]>zam)
                {
                    zaliha[3-k]-=zam;
                    a[i][3-j]=zam;
                    zam=0;
                }
                else
                {
                    zam=zam-zaliha[3-k];
                    a[i][3-j]=zaliha[3-k];
                    zaliha[3-k]=0;
                }

            }
            if(j>3)
             {
              cout<<"nemoguce";
              return 0;
             }
        }
    }
    for(j=3;j>1;j--)
    {
        for(i=0;i<n;i++)
        {
            while(a[i][j]==0)
            i++;
            if(zaliha[j]==0)
            {
                a[i][0]=a[i][j];
            }
            else if(zaliha[j]>a[i][j])
            {
                zaliha[j]-=a[i][j];
            }
            else
            {
                a[i][0]=a[i][j]-zaliha[j];
                a[i][j]=zaliha[j];
                zaliha[j]=0;
            }
        }
    }
    for(i=0;i<n;i++)
    {
        while(a[i][0]==0)
            i++;
        if(zaliha[j]>a[i][j])
            {
                zaliha[j]-=a[i][j];
            }
        else
            {
                cout<<"nemoguce";
                return 0;
            }
    }
    cout<<"moguce";
    for(i=0;i<n;i++)
    {
        for(j=0;j<4;j++)
            cout<<a[i][j]<<" ";
        cout<<endl;
    }
    return 0;
}